require('files')
require('stringutil')

-- name of the message in VMD file
VMD_MSG_NAME = 'ADT'

function main(Data)
   local Td=parseCSV(Data)
   print(Td)
   
   local T=ProcessCSV(Td)
   if T then 
      db.merge{api=db.MY_SQL, name='test', live=true,
         user='root', password='password', data=T}
   end
end

function parseCSV(Data)
   local T=Data:split('\n')
   local Td={}
   local ts={}
   for i=1,#T do
      Td[i]={}
      ts=T[i]:splitQ(',','"')
      for j=1,#ts do 
         Td[i][j]=ts[j]:trimWS()
      end
   end
   return Td
end


function ProcessCSV(csv)
   local Out = db.tables({vmd = 'demo_v2.vmd', name = VMD_MSG_NAME})
   local T={}
   local UnRowCnt=0 --uprocessed rows
   for i=1,#csv do
      if not csv[i][1]:find(".csv") and not csv[i][1]:find("Id") then
         T=MapCSV(csv[i],Out,i-UnRowCnt)
      else
         UnRowCnt=UnRowCnt+1
      end
   end
   return Out
end


function MapCSV(csvRow, Out, row)
    -- filter out unwanted rows 
   -- assumes all files are csv and first field is "*Id*"
   -- add the mappings here
   Out.patient[row].Id=csvRow[1]
   Out.patient[row].LastName=csvRow[2]
   Out.patient[row].GivenName=csvRow[3]
   Out.patient[row].Race=csvRow[4]
   -- canot map NULL fields in sample data
   --Out.patient[1].PhoneHome=csvRow[5]
   --Out.patient[1].PhoneBusiness=csvRow[6]
   --Out.patient[1].Religion=csvRow[7]
   Out.patient[row].MaritalStatus=csvRow[8]
   Out.patient[row].Ssn=csvRow[9]
   Out.patient[row].LicenseNumber=csvRow[10]
   Out.patient[row].Sex=csvRow[11]
   Out.patient[row].Dob=csvRow[12]
   Out.patient[row].Comment=csvRow[13]
   Out.patient[row].MsgTest=csvRow[14]
   return Out
end